<template>
  <v-app>
    <div class="overlay">
      <div class="container">
        <div class="row">
          <v-col cols="6" v-for="(list, index) in lists" :key="index">
            <div class="box">
              <div class="head mb-5">
                <div class="list-title">
                  <div class="box pa-3 mb-5">
                    <h3>
                      {{ list.title }}
                    </h3>
                  </div>
                </div>
                <v-btn @click="removeList(index)">Remove List</v-btn>
              </div>

              <div class="box pa-3">
                <div
                  class="card-title box mb-3 pa-3"
                  v-for="(task, i) in list.tasks"
                  :key="i"
                  v-bind:class="{
                    red: task.color == 'Red',
                    green: task.color == 'Green',
                    yellow: task.color == 'Yellow',
                  }"
                >
                  <h3>{{ task.title }}</h3>
                  <p class="mb-0">{{ task.description }}</p>
                </div>
                <v-dialog v-model="dialog" persistent max-width="600px">
                  <template v-slot:activator="{ on }">
                    <v-btn v-on="on" class="my-3">Task Details</v-btn>
                  </template>
                  <v-card>
                    <v-card-title>
                      <span class="headline">User Profile</span>
                    </v-card-title>
                    <v-card-text>
                      <v-container>
                        <v-row>
                          <v-col cols="12">
                            <v-text-field
                              label="Enter Task"
                              v-model="addTaskTitle"
                              solo
                              required
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12">
                            <v-textarea
                              v-model="addTaskDes"
                              label="Enter your Description"
                              solo
                            ></v-textarea>
                          </v-col>
                          <v-col cols="12">
                            <v-select
                              v-model="selectedColor"
                              :items="colors"
                              label="Task Color"
                              solo
                              required
                            ></v-select>
                          </v-col>
                          <v-col cols="12">
                            <v-btn
                              @keyup.enter="addtaskFn(index)"
                              @click="addtaskFn(index)"
                            >
                              Save
                            </v-btn>
                          </v-col>
                        </v-row>
                      </v-container>
                    </v-card-text>
                  </v-card>
                </v-dialog>
              </div>
            </div>
          </v-col>
          <v-col cols="6">
            <div class="box">
              <v-text-field
                class="list-input"
                v-model="addList"
                solo
                @keyup.enter="addList"
                :error-messages="errors"
                label="List Title"
                required
              ></v-text-field>
              <v-btn class="mr-4" @click="addListfn">add list</v-btn>
            </div>
          </v-col>
        </div>
      </div>
    </div>
  </v-app>
</template>

<script>
export default {
  data() {
    return {
      addList: '',
      lists: [],
      addTaskTitle: '',
      addTaskDes: '',
      colors: ['Red', 'Green', 'Yellow'],
      color: 'no-color',
      dialog: false,
      selectedColor: '',
    };
  },
  methods: {
    addListfn() {
      var post = {
        title: this.addList,
        tasks: [],
      };
      this.lists.push(post);
      this.addList = null;
    },
    addtaskFn(i) {
      var post = {
        title: this.addTaskTitle,
        description: this.addTaskDes,
        color: this.selectedColor,
      };
      this.lists[i].tasks.push(post);
      this.addTaskTitle = null;
      this.addTaskDes = null;
      this.dialog = false;
      this.selectedColor = null;
    },
    removeList(index) {
      this.lists.splice(index, 1);
    },
  },
};
</script>

<style lang="scss">
#app {
  background-color: rgba($color: #333, $alpha: 1);
  z-index: 0;
  font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen,
    Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
}
v-text-field {
  color: white;
}

.container {
  width: 80% !important;
  margin: 0 auto;
  color: white;
  z-index: 999;
}
.box {
  border: 1px solid white;
  z-index: 999999;
  padding: 30px;
  border-radius: 5px;
  background-color: rgba(250, 250, 250, 0.2);
}
.theme--light.v-card {
  background-color: rgba(250, 250, 250, 0.8) !important;
}
.red {
  background-color: rgba(201, 59, 48, 0.6) !important;
}
.green {
  background-color: rgba(103, 173, 55, 0.6) !important;
}
.yellow {
  background-color: rgba(186, 175, 24, 0.6) !important;
}
.no-color {
  background-color: transparent;
}
</style>
